searchNodes=[{"doc":"Extend Commanded package. A swiss army knife for applications following Domain-Driven Design (DDD), Event Sourcing (ES), and Command and Query Responsibility Segregation (CQRS).","ref":"OnePiece.Commanded.html","title":"OnePiece.Commanded","type":"module"},{"doc":"See OnePiece.Commanded.Helpers.cast_to/3 .","ref":"OnePiece.Commanded.html#cast_to/3","title":"OnePiece.Commanded.cast_to/3","type":"function"},{"doc":"See OnePiece.Commanded.Helpers.increase_failure_counter/1 .","ref":"OnePiece.Commanded.html#increase_failure_counter/1","title":"OnePiece.Commanded.increase_failure_counter/1","type":"function"},{"doc":"See OnePiece.Commanded.Helpers.skip_or_retry/2 .","ref":"OnePiece.Commanded.html#skip_or_retry/2","title":"OnePiece.Commanded.skip_or_retry/2","type":"function"},{"doc":"See OnePiece.Commanded.Helpers.skip_or_retry/3 .","ref":"OnePiece.Commanded.html#skip_or_retry/3","title":"OnePiece.Commanded.skip_or_retry/3","type":"function"},{"doc":"See OnePiece.Commanded.Helpers.tracing_from_metadata/1 .","ref":"OnePiece.Commanded.html#tracing_from_metadata/1","title":"OnePiece.Commanded.tracing_from_metadata/1","type":"function"},{"doc":"See OnePiece.Commanded.Helpers.tracing_from_metadata/2 .","ref":"OnePiece.Commanded.html#tracing_from_metadata/2","title":"OnePiece.Commanded.tracing_from_metadata/2","type":"function"},{"doc":"Defines &quot;Aggregate&quot; modules.","ref":"OnePiece.Commanded.Aggregate.html","title":"OnePiece.Commanded.Aggregate","type":"behaviour"},{"doc":"Convert the module into a Aggregate behaviour. Usage defmodule Account do use OnePiece.Commanded.Aggregate @impl OnePiece.Commanded.Aggregate def apply ( account , event ) do account |&gt; Map . put ( :name , event . name ) |&gt; Map . put ( :description , event . description ) end end","ref":"OnePiece.Commanded.Aggregate.html#__using__/1","title":"OnePiece.Commanded.Aggregate.__using__/1","type":"macro"},{"doc":"Apply a given event to the aggregate returning the new aggregate state. Example def apply ( account , event ) do account |&gt; Map . put ( :name , event . name ) |&gt; Map . put ( :description , event . description ) end","ref":"OnePiece.Commanded.Aggregate.html#c:apply/2","title":"OnePiece.Commanded.Aggregate.apply/2","type":"callback"},{"doc":"","ref":"OnePiece.Commanded.Aggregate.html#t:event/0","title":"OnePiece.Commanded.Aggregate.event/0","type":"type"},{"doc":"","ref":"OnePiece.Commanded.Aggregate.html#t:t/0","title":"OnePiece.Commanded.Aggregate.t/0","type":"type"},{"doc":"Defines &quot;Command&quot; modules.","ref":"OnePiece.Commanded.Command.html","title":"OnePiece.Commanded.Command","type":"module"},{"doc":"Converts the module into an Ecto.Schema . It derives from Jason.Encoder and also adds some factory functions to create structs. Usage defmodule MyCommand do use OnePiece.Commanded.Command , aggregate_identifier : :id embedded_schema do # ... end end","ref":"OnePiece.Commanded.Command.html#__using__/1","title":"OnePiece.Commanded.Command.__using__/1","type":"macro"},{"doc":"","ref":"OnePiece.Commanded.Command.html#t:t/0","title":"OnePiece.Commanded.Command.t/0","type":"type"},{"doc":"Defines a module as a &quot;Command Handler&quot;. For more information about commands, please read the following: CQRS pattern","ref":"OnePiece.Commanded.CommandHandler.html","title":"OnePiece.Commanded.CommandHandler","type":"module"},{"doc":"Convert the module into a Commanded.Commands.Handler . Use Commanded.Aggregate.Multi to generate multiple events from a single command. This can be useful when you want to emit multiple events that depend upon the aggregate state being updated. Usage defmodule MyCommandHandler do use OnePiece.Commanded.CommandHandler @impl Commanded.Commands.Handler def handle ( account , command ) do account |&gt; Multi . new ( ) |&gt; Multi . execute ( &amp; withdraw_money ( &amp;1 , command . amount ) ) |&gt; Multi . execute ( &amp; check_balance / 1 ) end defp withdraw_money ( account , amount ) do # ... end defp check_balance ( account , amount ) do # ... end end","ref":"OnePiece.Commanded.CommandHandler.html#__using__/1","title":"OnePiece.Commanded.CommandHandler.__using__/1","type":"macro"},{"doc":"Defines &quot;Entity&quot; modules.","ref":"OnePiece.Commanded.Entity.html","title":"OnePiece.Commanded.Entity","type":"module"},{"doc":"Converts the module into an Ecto.Schema . It derives from Jason.Encoder and also adds some factory functions to create structs. Usage defmodule MyEntity do use OnePiece.Commanded.Entity , identifier : :id embedded_schema do # ... end end","ref":"OnePiece.Commanded.Entity.html#__using__/1","title":"OnePiece.Commanded.Entity.__using__/1","type":"macro"},{"doc":"The identity of an entity.","ref":"OnePiece.Commanded.Entity.html#t:identity/0","title":"OnePiece.Commanded.Entity.identity/0","type":"type"},{"doc":"Defines &quot;Event&quot; modules.","ref":"OnePiece.Commanded.Event.html","title":"OnePiece.Commanded.Event","type":"module"},{"doc":"Converts the module into an Ecto.Schema . It derives from Jason.Encoder . Usage defmodule MyEvent do use OnePiece.Commanded.Event , aggregate_identifier : :id embedded_schema do # ... end end","ref":"OnePiece.Commanded.Event.html#__using__/1","title":"OnePiece.Commanded.Event.__using__/1","type":"macro"},{"doc":"","ref":"OnePiece.Commanded.Event.html#t:t/0","title":"OnePiece.Commanded.Event.t/0","type":"type"},{"doc":"A Swiss Army Knife Helper Module.","ref":"OnePiece.Commanded.Helpers.html","title":"OnePiece.Commanded.Helpers","type":"module"},{"doc":"Copy the information from the source map into the given target map. iex&gt; OnePiece.Commanded.Helpers . cast_to ( %{ } , %{ name : &quot;ubi-wan&quot; , last_name : &quot;kenobi&quot; } , [ :last_name ] ) %{ last_name : &quot;kenobi&quot; }","ref":"OnePiece.Commanded.Helpers.html#cast_to/3","title":"OnePiece.Commanded.Helpers.cast_to/3","type":"function"},{"doc":"Deprecated, it has the same behavior as OnePiece.Commanded.Id.new/0 .","ref":"OnePiece.Commanded.Helpers.html#generate_uuid/0","title":"OnePiece.Commanded.Helpers.generate_uuid/0","type":"function"},{"doc":"Increase the failure counter from Commanded.Event.FailureContext.t/0 context by one. iex&gt; OnePiece.Commanded.Helpers . increase_failure_counter ( % Commanded.Event.FailureContext { context : %{ failures_count : 1 } } ) %{ failures_count : 2 }","ref":"OnePiece.Commanded.Helpers.html#increase_failure_counter/1","title":"OnePiece.Commanded.Helpers.increase_failure_counter/1","type":"function"},{"doc":"Returns skip or a retry response. When the Commanded.Application.dispatch/1 or Commanded.Application.dispatch/2 returns an :skip otherwise, returns a :retry response. Useful when you are doing error handling in your Commanded.Event.Handler.error/3 . iex&gt; success_dispatch = fn _ -&gt; :ok end ...&gt; OnePiece.Commanded.Helpers . skip_or_retry ( success_dispatch . ( %{ } ) , %{ } ) :skip iex&gt; success_dispatch = fn _ -&gt; { :ok , %{ } } end ...&gt; OnePiece.Commanded.Helpers . skip_or_retry ( success_dispatch . ( %{ } ) , %{ } ) :skip iex&gt; failure_dispatch = fn _ -&gt; { :error , :ooops } end ...&gt; OnePiece.Commanded.Helpers . skip_or_retry ( failure_dispatch . ( %{ } ) , %{ failures : 1 } ) { :retry , %{ failures : 1 } }","ref":"OnePiece.Commanded.Helpers.html#skip_or_retry/2","title":"OnePiece.Commanded.Helpers.skip_or_retry/2","type":"function"},{"doc":"Returns skip or a retry response with a given delay. When the Commanded.Application.dispatch/1 or Commanded.Application.dispatch/2 returns an :skip otherwise, returns a :retry response. Useful when you are doing error handling in your Commanded.Event.Handler.error/3 . iex&gt; success_dispatch = fn _ -&gt; :ok end ...&gt; OnePiece.Commanded.Helpers . skip_or_retry ( success_dispatch . ( %{ } ) , 5_000 , %{ } ) :skip iex&gt; success_dispatch = fn _ -&gt; { :ok , %{ } } end ...&gt; OnePiece.Commanded.Helpers . skip_or_retry ( success_dispatch . ( %{ } ) , 5_000 , %{ } ) :skip iex&gt; failure_dispatch = fn _ -&gt; { :error , :ooops } end ...&gt; OnePiece.Commanded.Helpers . skip_or_retry ( failure_dispatch . ( %{ } ) , 5_000 , %{ failures : 1 } ) { :retry , 5_000 , %{ failures : 1 } }","ref":"OnePiece.Commanded.Helpers.html#skip_or_retry/3","title":"OnePiece.Commanded.Helpers.skip_or_retry/3","type":"function"},{"doc":"Transforms the given source map or struct into the target struct.","ref":"OnePiece.Commanded.Helpers.html#struct_from/2","title":"OnePiece.Commanded.Helpers.struct_from/2","type":"function"},{"doc":"Returns a keyword list containing the &quot;correlation id&quot; and &quot;causation id&quot; tracing. iex&gt; OnePiece.Commanded.Helpers . tracing_from_metadata ( %{ ...&gt; event_id : &quot;26eb06fe-9ba6-4f58-a2dd-2bdba73de4f2&quot; , ...&gt; correlation_id : &quot;f634ba94-145c-4fa7-bf7f-0d73dd83b446&quot; ...&gt; } ) ...&gt; [ causation_id : &quot;26eb06fe-9ba6-4f58-a2dd-2bdba73de4f2&quot; , correlation_id : &quot;f634ba94-145c-4fa7-bf7f-0d73dd83b446&quot; ] Useful when dispatching commands to copy-forward Commanded.Event.Handler.metadata/0 tracing information. defmodule MyProcessor do application : MyApp , use Commanded.Event.Handler , name : &quot;my_processor&quot; alias OnePiece.Commanded.Helpers def handle ( % MyEvent { } = event , metadata ) do MyApp . dispatch ( % MyCommand { } , # copy-forward the information Helpers . tracing_from_metadata ( metadata ) ) end end","ref":"OnePiece.Commanded.Helpers.html#tracing_from_metadata/1","title":"OnePiece.Commanded.Helpers.tracing_from_metadata/1","type":"function"},{"doc":"Adds the &quot;correlation id&quot; and &quot;causation id&quot; tracing to an existing keyword list configuration option. iex&gt; OnePiece.Commanded.Helpers . tracing_from_metadata ( [ timeout : 30_000 ] , %{ ...&gt; event_id : &quot;26eb06fe-9ba6-4f58-a2dd-2bdba73de4f2&quot; , ...&gt; correlation_id : &quot;f634ba94-145c-4fa7-bf7f-0d73dd83b446&quot; ...&gt; } ) ...&gt; [ timeout : 30_000 , causation_id : &quot;26eb06fe-9ba6-4f58-a2dd-2bdba73de4f2&quot; , correlation_id : &quot;f634ba94-145c-4fa7-bf7f-0d73dd83b446&quot; ] Useful when dispatching commands to copy-forward the Commanded.Event.Handler.metadata/0 tracing information and wants to also add other keyword list options. defmodule MyProcessor do use Commanded.Event.Handler , application : MyApp , name : &quot;my_processor&quot; alias OnePiece.Commanded.Helpers def handle ( % MyEvent { } = event , metadata ) do MyApp . dispatch ( % MyCommand { } , # copy-forward the information Helpers . tracing_from_metadata ( [ timeout : 30_000 ] , metadata ) ) end end","ref":"OnePiece.Commanded.Helpers.html#tracing_from_metadata/2","title":"OnePiece.Commanded.Helpers.tracing_from_metadata/2","type":"function"},{"doc":"","ref":"OnePiece.Commanded.Helpers.html#t:commanded_dispatch_response/0","title":"OnePiece.Commanded.Helpers.commanded_dispatch_response/0","type":"type"},{"doc":"","ref":"OnePiece.Commanded.Helpers.html#t:error_context/0","title":"OnePiece.Commanded.Helpers.error_context/0","type":"type"},{"doc":"A module for dealing IDs.","ref":"OnePiece.Commanded.Id.html","title":"OnePiece.Commanded.Id","type":"behaviour"},{"doc":"Generates a UUID using the version 4 scheme, as described in RFC 4122 . iex&gt; OnePiece.Commanded.Id . new ( ) |&gt; String . length ( ) 36","ref":"OnePiece.Commanded.Id.html#new/0","title":"OnePiece.Commanded.Id.new/0","type":"function"},{"doc":"Generates a new ID.","ref":"OnePiece.Commanded.Id.html#c:new/0","title":"OnePiece.Commanded.Id.new/0","type":"callback"},{"doc":"Defines a module as a &quot;Query Handler&quot;. For more information about queries, please read the following: CQRS pattern","ref":"OnePiece.Commanded.QueryHandler.html","title":"OnePiece.Commanded.QueryHandler","type":"behaviour"},{"doc":"Convert the module into a OnePiece.Commanded.QueryHandler . Usage defmodule MyQueryHandler do use OnePiece.Commanded.QueryHandler import Ecto.Query , only : [ from : 2 ] @impl OnePiece.Commanded.QueryHandler def handle ( params ) do query = from u in User , where : u . age &gt; 18 or is_nil ( params . email ) , select : u { :ok , Repo . all ( query ) } end end","ref":"OnePiece.Commanded.QueryHandler.html#__using__/1","title":"OnePiece.Commanded.QueryHandler.__using__/1","type":"macro"},{"doc":"Handle the incoming params and return the result data.","ref":"OnePiece.Commanded.QueryHandler.html#c:handle/1","title":"OnePiece.Commanded.QueryHandler.handle/1","type":"callback"},{"doc":"","ref":"OnePiece.Commanded.QueryHandler.html#t:error/0","title":"OnePiece.Commanded.QueryHandler.error/0","type":"type"},{"doc":"","ref":"OnePiece.Commanded.QueryHandler.html#t:view_model/0","title":"OnePiece.Commanded.QueryHandler.view_model/0","type":"type"},{"doc":"This module helps with test cases for testing aggregate states, and command handlers. Usage After import the test support file, you should be able to have the module in your test files. defmodule MyAggregateTest do use OnePiece.Commanded.TestSupport.CommandHandlerCase , aggregate : MyAggregate , # You can also pass `handler` if you are using Command Handler modules # handler: MyCommandHandler, async : true describe &quot;my aggregate&quot; do test &quot;should do something&quot; do assert_events ( [ % InitialEvent { } ] % DoSomething { } , [ % SomethingHappened { } ] ) end test &quot;the state&quot; do assert_state ( [ % InitialEvent { } ] % DoSomething { } , % MyAggregate { } ) end test &quot;the error&quot; do assert_error ( [ % InitialEvent { } ] % DoSomething { } , :already_exists ) end end end","ref":"OnePiece.Commanded.TestSupport.CommandHandlerCase.html","title":"OnePiece.Commanded.TestSupport.CommandHandlerCase","type":"module"},{"doc":"","ref":"OnePiece.Commanded.TestSupport.CommandHandlerCase.html#assert_error/5","title":"OnePiece.Commanded.TestSupport.CommandHandlerCase.assert_error/5","type":"function"},{"doc":"","ref":"OnePiece.Commanded.TestSupport.CommandHandlerCase.html#assert_events/5","title":"OnePiece.Commanded.TestSupport.CommandHandlerCase.assert_events/5","type":"function"},{"doc":"","ref":"OnePiece.Commanded.TestSupport.CommandHandlerCase.html#assert_state/5","title":"OnePiece.Commanded.TestSupport.CommandHandlerCase.assert_state/5","type":"function"},{"doc":"Implements Commanded.EventStore.TypeProvider behavior. Using macros to generate the behavior.","ref":"OnePiece.Commanded.TypeProvider.html","title":"OnePiece.Commanded.TypeProvider","type":"module"},{"doc":"Imports all the types from another module defined by OnePiece.Commanded.TypeProvider.TypeProvider . Example defmodule UserTypeProvider do use OnePiece.Commanded.TypeProvider # ... end defmodule MyAppTypeProvider do use OnePiece.Commanded.TypeProvider import_type_provider UserTypeProvider end","ref":"OnePiece.Commanded.TypeProvider.html#import_type_provider/1","title":"OnePiece.Commanded.TypeProvider.import_type_provider/1","type":"macro"},{"doc":"Registers a mapping from an name string to an Elixir Module that defines a struct. Example defmodule MyTypeProvider do use OnePiece.Commanded.TypeProvider , prefix : &quot;accounts.&quot; # optional, adds the prefix to the type name register_type &quot;account_created&quot; , AccountCreated end","ref":"OnePiece.Commanded.TypeProvider.html#register_type/2","title":"OnePiece.Commanded.TypeProvider.register_type/2","type":"macro"},{"doc":"Defines &quot;Value Object&quot; modules.","ref":"OnePiece.Commanded.ValueObject.html","title":"OnePiece.Commanded.ValueObject","type":"module"},{"doc":"Converts the module into an Ecto.Schema . It derives from Jason.Encoder and also adds some factory functions to create structs. Usage defmodule MyValueObject do use OnePiece.Commanded.ValueObject embedded_schema do field :title , :string # ... end end { :ok , my_value } = MyValueObject . new ( %{ title : &quot;Hello, World!&quot; } )","ref":"OnePiece.Commanded.ValueObject.html#__using__/1","title":"OnePiece.Commanded.ValueObject.__using__/1","type":"macro"},{"doc":"Extend Commanded package. A swiss army knife for applications following Domain-Driven Design (DDD), Event Sourcing ( ES), and Command and Query Responsibility Segregation (CQRS).","ref":"readme.html","title":"OnePiece.Commanded","type":"extras"},{"doc":"References API Reference","ref":"readme.html#documentation","title":"OnePiece.Commanded - Documentation","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Fix OnePiece.Commanded.Event and `OnePiece.Commanded.Entity to extend from OnePiece.Commanded.ValueObject . ## v0.15.0 - 2022-12-23 - Added overridable to OnePiece.Commanded.ValueObject.new/1 - Added overridable to OnePiece.Commanded.ValueObject.new!/1 - Added overridable to OnePiece.Commanded.ValueObject.changeset/2 ## v0.14.0 - 2022-09-4 - Added OnePiece.Commanded.increase_failure_counter/1 ## v0.13.0 - 2022-08-19 - Added OnePiece.Commanded.tracing_from_metadata/1 . - Added OnePiece.Commanded.tracing_from_metadata/2 . ## v0.12.0 - 2022-08-19 - Added OnePiece.Commanded.skip_or_retry/2 . - Added OnePiece.Commanded.skip_or_retry/3 . - Added OnePiece.Commanded.Helpers.skip_or_retry/3 . - Added OnePiece.Commanded.Helpers.skip_or_retry/3 . - Undo deprecation of OnePiece.Commanded.cast_to/3 . ## v0.11.1 - 2022-07-21 - Fix register type with a struct with enforce keys in OnePiece.Commanded.TypeProvider module. ## v0.11.0 - 2022-07-1 - Add OnePiece.Commanded.Helpers.tracing_from_metadata/1 - Add OnePiece.Commanded.Helpers.tracing_from_metadata/2 ## v0.10.1 - 2022-06-28 - Deprecate OnePiece.Commanded.cast_to/3 (wrong module) and delegate to OnePiece.Commanded.Helpers instead. - Add OnePiece.Commanded.Helpers.cast_to/3 ## v0.10.0 - 2022-06-23 - Add OnePiece.Commanded.cast_to/3 ## v0.9.1 - 2022-06-22 - Move test support under lib directory. ## v0.7.0 - 2022-02-14 - Added OnePiece.Commanded.Id - Deprecated OnePiece.Commanded.Helpers.generate_uuid/0 . Use OnePiece.Commanded.Id.new/0 instead. ## v0.6.0 - 2022-02-14 - Added prefix option to using OnePiece.Commanded.TypeProvider elixir defmodule MyTypeProvider do use OnePiece.Commanded.TypeProvider, prefix: &quot;accounts.&quot; end ## v0.5.0 - 2022-02-14 - Added OnePiece.Commanded.TypeProvider ## v0.4.0 - 2021-11-25 - Improve documentation ## v0.4.0 - 2021-08-15 - Add OnePiece.Commanded.Event module ## v0.3.0 - 2021-08-15 - Fix docs - Fix version bump ## v0.2.1 - 2021-08-15 - Add test support files ## v0.2.0 - 2021-08-08 - Fix putting aggregate id to command function name ## v0.1.3 - 2021-08-08 - Fix aliases ## v0.1.2 - 2021-08-08 - Fix __using__ for aggregate, command handler, query handler, and value object ## v0.1.1 - 2021-08-08 - Remove dead-code ## v0.1.0 - 2021-08-08 - Initial release","ref":"changelog.html#v0-15-1-2022-12-24","title":"Changelog - v0.15.1 - 2022-12-24","type":"extras"}]